      PROGRAM DDSCAT
! Februray 2008
! PJF mods to reapar.f to incude "namelist"
!This is simple test of reapar.f rewritten using namelist

!My (PJF) comments begin with  !f90

!WARNING
!I did not properly converted last section of reapar.f which reads data fro
!PHI1,THETA1,THETA2,DTHETA
!my version does only one phi plane
!I think that the best solution may be to introduce arrays phi, theta1, theta2
!

      IMPLICIT NONE

      INTEGER
     &   ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORI0,IORTH,IPHM,IRAD0,IWAV0,
     &   IWRKSC,
     &   MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &   NBETA,NCOMP,NPHI,NRAD,NSCA,NSMELTS,NWAV,NTHETA

      parameter (mxwav=100)
      parameter (mxrad=100)
      parameter (mxphi=100)
      parameter (mxbeta=100)
      parameter (mxthet=100)
      parameter (mxsca=200)

      REAL
     &   BETAMI,BETAMX,DEGRAD,PHIMIN,PHIMAX,THETMI,THETMX,TOL
      REAL
     &   AEFFA(MXRAD),DX(3),PHIN(MXSCA),SHPAR(6),THETAN(MXSCA),
     &   WAVEA(MXWAV)
      COMPLEX CXE01(3),CXE02(3)
      DATA IOPAR/1/
      PARAMETER(MXCOMP=9)
      INTEGER SMIND1(9),SMIND2(9)
      CHARACTER CMDFFT*6
      CHARACTER CMDSOL*6,CMDTRQ*6,CMSGNM*70
      CHARACTER
     &   CALPHA*6,CDIEL*6,CSHAPE*6,CSTAMP*22,
     &   CFLAVG*13,CFLPAR*13,CFLSCA*14,CFLSHP*13,CDESCR*67,
     &   CBINFLAG*6, CBINFILE*14, CNETFLAG*6, CNETFILE*14
      CHARACTER CFLLOG*14
      CHARACTER*60 CFLEPS(MXCOMP)

!f90 test of FORTRAN90 reapar.f
      CFLPAR='ddscatpar.nml'
      degrad=4.*atan(1.)/180.

      call REAPAR(CBINFLAG,CNETFLAG,AEFFA,
     &                  BETAMI,BETAMX,
     &                  CALPHA,CDIEL,CFLEPS,CFLPAR,CFLSHP,CMDSOL,CMDFFT,
     &                  CSHAPE,CMDTRQ,CXE01,CXE02,
     &                  DEGRAD,
     &                  ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORTH,IPHM,
     &                  IWRKSC,
     &                  MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,
     &                  MXWAV,
     &                  NBETA,NCOMP,NPHI,NRAD,NSCA,NTHETA,NWAV,
     &                  IWAV0,IRAD0,IORI0,NSMELTS,
     &                  PHIMIN,PHIMAX,PHIN,
     &                  THETAN,THETMI,THETMX,TOL,
     &                  WAVEA,SHPAR,SMIND1,SMIND2,DX)

      stop
      end

      SUBROUTINE REAPAR(CBINFLAG,CNETFLAG,AEFFA,
     &                  BETAMI,BETAMX,
     &                  CALPHA,CDIEL,CFLEPS,CFLPAR,CFLSHP,CMDSOL,CMDFFT,
     &                  CSHAPE,CMDTRQ,CXE01,CXE02,
     &                  DEGRAD,
     &                  ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORTH,IPHM,
     &                  IWRKSC,
     &                  MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,
     &                  MXWAV,
     &                  NBETA,NCOMP,NPHI,NRAD,NSCA,NTHETA,NWAV,
     &                  IWAV0,IRAD0,IORI0,NSMELTS,
     &                  PHIMIN,PHIMAX,PHIN,
     &                  THETAN,THETMI,THETMX,TOL,
     &                  WAVEA,SHPAR,SMIND1,SMIND2,DX)
      IMPLICIT NONE
!
! Arguments:
!
!f90 character need to be of constant vale (for namelist to work)
      CHARACTER CMDFFT*6
      CHARACTER CMDSOL*6,CMDTRQ*6,CMSGNM*70
      CHARACTER
     &   CALPHA*6,CDIEL*6,CSHAPE*6,CSTAMP*22,
     &   CFLAVG*13,CFLPAR*13,CFLSCA*14,CFLSHP*13,CDESCR*67,
     &   CBINFLAG*6, CBINFILE*14, CNETFLAG*6, CNETFILE*14
      CHARACTER CFLLOG*14

      INTEGER
     &   ICTHM,IDVERR,IDVOUT,INIT,IOPAR,IORI0,IORTH,IPHM,IRAD0,IWAV0,
     &   IWRKSC,
     &   MXBETA,MXCOMP,MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,
     &   NBETA,NCOMP,NPHI,NRAD,NSCA,NSMELTS,NWAV,NTHETA
      INTEGER SMIND1(9),SMIND2(9)
!f90 new variable ndirs
      integer idirs, ndirs

!f90 - I have to make cfleps(9) explicit so it can be in the namelist
!g90 perhaps namelist should be in the main program?

      CHARACTER*60 CFLEPS(9)
      REAL
     &   BETAMI,BETAMX,DEGRAD,PHIMIN,PHIMAX,THETMI,THETMX,TOL
      REAL
     &   AEFFA(MXRAD),DX(3),PHIN(MXSCA),SHPAR(6),THETAN(MXSCA),
     &   WAVEA(MXWAV)
      COMPLEX CXE01(3),CXE02(3)
!
! Local variables:
!
!f90 have to remove cdivid*3 and replace it with unique names
!f90 introduced new name crad*3
!f90 instrodued new name cwav*3 
      CHARACTER CLINE*70, CRAD*3, CWAV*3
      INTEGER J,NSCA0
      REAL
     &   AEFEND,AEFINI,DELTA,DTHETA,E1,PHI1,THETA1,THETA2,
     &   WAVEND,WAVINI
!
! External routines:
!
      EXTERNAL DIVIDE,ERRMSG,WRIMSG

! Fortran90 reapar.f

      namelist /preliminaries/ CMDTRQ, CMDSOL, CMDFFT, CALPHA, CBINFLAG,
     +         CNETFLAG, CSHAPE, SHPAR, CFLSHP, NCOMP, CDIEL,
     +         CFLEPS, INIT, TOL, ICTHM, IPHM, WAVINI, WAVEND, NWAV, 
     +         CWAV,AEFINI, AEFEND, NRAD, CRAD, CXE01, IORTH, IWRKSC,
     +         BETAMI, BETAMX, NBETA, THETMI, THETMX, NTHETA, 
     +         PHIMIN, PHIMAX, NPHI, IWAV0, IRAD0, IORI0, 
     +         NSMELTS, SMIND1, NDIRS, PHI1, THETA1, THETA2, DTHETA

      OPEN (UNIT=IOPAR,FILE=CFLPAR,STATUS='OLD')
!read in namelist
      read(iopar,nml=preliminaries)

C
C    Specify whether torques are to be calculated:
C
C    CMDTRQ*6 = 'DOTORQ' -  calculate torque on grain
C             = 'NOTORQ' -  do not calculate torque on grain
C
!f90      READ(IOPAR,FMT=*,ERR=40)CMDTRQ
      IF(CMDTRQ.EQ.'dotorq')CMDTRQ='DOTORQ'
      IF(CMDTRQ.EQ.'notorq')CMDTRQ='NOTORQ'
      IF(CMDTRQ.EQ.'DOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDTRQ.EQ.'NOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - do not compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDTRQ')
      ENDIF
C
C    Define method used for iterative solution of complex linear equations
C
C    CMDSOL*6 = 'PETRKP' -  Petravic & Kuo-Petravic method
C             = 'PBCGST' -  PIM BiConjugate Gradient with Stabilization
C
!g90      READ(IOPAR,FMT=*,ERR=40)CMDSOL
      IF(CMDSOL.EQ.'petrkp')CMDSOL='PETRKP'
      IF(CMDSOL.EQ.'pbcgst')CMDSOL='PBCGST'
      IF(CMDSOL.EQ.'PETRKP'.OR.
     &   CMDSOL.EQ.'PBCGST')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDSOL,' - CCG Method  '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDSOL')
      ENDIF
C
C    Define FFT method:
C
C    CMDFFT*6 = 'BRENNR' -  Use Brenner's FOURX FFT routine [no longer used]
C             = 'TMPRTN' -  Use Temperton's FFT routine [no longer used]
C             = 'GPFAFT' -  GPFA code of Temperton
C             = 'FFTW21' -  FFTW 2.1.x code of Frigo & Johnson
C             = 'CONVEX' -  Use native Convex veclib routine C3DFFT.
C
!f90      READ(IOPAR,FMT=*,ERR=40)CMDFFT
      IF(CMDFFT.EQ.'CONVEX')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using native Convex ',
     &                    '3d FFT'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDFFT.EQ.'FFTW21')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using FFTW 2.1.x ',
     &                    'package from Frigo & Johnson'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDFFT.EQ.'GPFAFT')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using GPFA package ',
     &                    'from Clive Temperton'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         WRITE(CMSGNM,FMT='(A,A)')'DDSCAT6.0 only supports FFT options',
     &      ' FFTW21, GPFAFT, and CONVEX'
         CALL WRIMSG('REAPAR',CMSGNM)
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDFFT')
      ENDIF
C
C***********************************************************************
C
C    Define prescription for computing polarizabilities:
C
C    CALPHA*6 = 'LATTDR' - Lattice Dispersion Relation of
C                          Draine & Goodman (1993)
C
!f90      READ(IOPAR,FMT=*,ERR=40)CALPHA
      IF(CALPHA.EQ.'LATTDR')THEN
         CALL WRIMSG('REAPAR',
     &      'LATTDR - Draine & Goodman (1993) LDR for alpha')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CALPHA')
      ENDIF
C
C binary file flag
!f90      READ(IOPAR,FMT=*,ERR=40)CBINFLAG
      IF(CBINFLAG.EQ.'allbin')CBINFLAG='ALLBIN'
      IF(CBINFLAG.EQ.'oribin')CBINFLAG='ORIBIN'
      IF(CBINFLAG.EQ.'notbin')CBINFLAG='NOTBIN'
      IF(CBINFLAG.EQ.'ALLBIN'
     &   .OR.CBINFLAG.EQ.'ORIBIN'
     &   .OR.CBINFLAG.EQ.'NOTBIN')THEN
         WRITE(CMSGNM,FMT='(A,A)')CBINFLAG,
     &                            ' - Unformatted binary dump option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CBINFLAG')
      ENDIF
C
C binary file flag
!f90      READ(IOPAR,FMT=*,ERR=40)CNETFLAG
      IF(CNETFLAG.EQ.'allcdf')CNETFLAG='ALLCDF'
      IF(CNETFLAG.EQ.'oricdf')CNETFLAG='ORICDF'
      IF(CNETFLAG.EQ.'notcdf')CNETFLAG='NOTCDF'
      IF(CNETFLAG.EQ.'ALLCDF'  
     &   .OR.CNETFLAG.EQ.'ORICDF' 
     &   .OR.CNETFLAG.EQ.'NOTCDF')THEN
         WRITE(CMSGNM,FMT='(A,A)')CNETFLAG,
     &                            ' - netCDF file option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CNETFLAG')
      ENDIF

C
C***********************************************************************
C
C    Define shape:
C
C    CSHAPE*6 = 'FRMFIL'     read shape data from file
C             = 'RCTNGL'     make rectangular solid
C             = 'ELLIPS'     make ellipsoidal solid
C             = 'CYLNDR'     make cylindrical solid
C             = 'HEXGON'     make hexagonal prism
C             = 'TETRAH'     make regular tetrahedron
C             = 'UNICYL'     make cylinder of unixaxial material
C             = 'ANIELL'     make ellipsoid of anisotropic material
C             = 'TWOELL'     make two touching ellipsoids of materials 1,2
C             = 'TWOAEL'     make two touching anisotropic ellipsoids of
C                            materials 1-6
C             = 'THRELL'     make three touching isotropic ellipsoids of
C                            materials 1,2,3
C             = 'THRAEL'     make three touching anisotropic ellipsoids of
C                            materials 1-9
C             = 'CONELL'     make two concentric ellipsoids of
C                            materials 1,2
C             = 'BLOCKS'     make target out of cubic blocks defined by
C                            data in file 'blocks.par'
C             = 'DW1996'     make 13-cube target used by Draine &
C                            Weingartner 1996
C             = 'TWOSPH'     make two touching spheroids with symmetry axes at
C                            specified angle
C             = 'LYRSLB'     make layered slab target, with up to 4 separate
C                            layers
C             = 'NSPHER'     make multisphere target = union of volumes of
C                            N spheres
C             = 'PRISM3'     make triangular prism target
C
C             = 'SPHARM'     make spherical harmonic target
C
!f90      READ(IOPAR,FMT=*,ERR=40)CSHAPE
      IF(    CSHAPE.EQ.'FRMFIL'
     &   .OR.CSHAPE.EQ.'RCTNGL'
     &   .OR.CSHAPE.EQ.'ELLIPS'
     &   .OR.CSHAPE.EQ.'CYLNDR'
     &   .OR.CSHAPE.EQ.'HEXGON'
     &   .OR.CSHAPE.EQ.'TETRAH'
     &   .OR.CSHAPE.EQ.'UNICYL'
     &   .OR.CSHAPE.EQ.'ANIELL'
     &   .OR.CSHAPE.EQ.'TWOELL'
     &   .OR.CSHAPE.EQ.'TWOAEL'
     &   .OR.CSHAPE.EQ.'THRELL'
     &   .OR.CSHAPE.EQ.'THRAEL'
     &   .OR.CSHAPE.EQ.'CONELL'
     &   .OR.CSHAPE.EQ.'BLOCKS'
     &   .OR.CSHAPE.EQ.'DW1996'
     &   .OR.CSHAPE.EQ.'LYRSLB'
     &   .OR.CSHAPE.EQ.'TWOSPH'
     &   .OR.CSHAPE.EQ.'NSPHER'
     &   .OR.CSHAPE.EQ.'PRISM3'
     &   .OR.CSHAPE.EQ.'SPHARM')THEN
C
         WRITE(CMSGNM,FMT='(A,A)')CSHAPE,' - Shape definition '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong shape directive ')
      ENDIF
C

C Read shape parameters
C Need 3 shape parameters for all options except 
C      FRMFIL (0 shape parameters: 
C                here skip a line, later read target from file)
C      TETRAH, DW1996 (1 shape parameter)
C      CYLNDR, HEXGON, UNICYL (2 shape parameters)
C      TWOSPH (6 shape parameters)
C      CONELL (6 shape parameters)
C      LYRSLB (6 shape parameters)
C      NSPHER (2 shape parameters + 1 filename)
C      PRISM3 (4 shape parameters)
C      SPHARM (1 shape parameter, later read file 'spharm.par'
!removed large section of the code because SHPAR(1..6) is defined
!or not (namelist has flexibility not to define a variable if not needed)


C
C***********************************************************************
C-----------------------------------------------------------------------
C following code disabled 03.01.29
C (retain for use in future version)
C
C   Obtain lattice anisotropy parameters DX(1-3)
C   For cubic lattice, DX(1)=DX(2)=DX(3)
C   Note that we do not require here that DX(1)*DX(2)*DX(3)=1 upon
C   input; DX is renormalized here before being returned to DDSCAT
C

C      READ(IOPAR,FMT=*,ERR=40)DX(1),DX(2),DX(3)
C      WRITE(CMSGNM,FMT='(F8.3,F8.3,F8.3,A)')DX,
C     &   ' = relative lattice spacings dx,dy,dz'
C      CALL WRIMSG('REAPAR',CMSGNM)

C      DELTA=(DX(1)*DX(2)*DX(3))**(1./3.)
C      DX(1)=DX(1)/DELTA
C      DX(2)=DX(2)/DELTA
C      DX(3)=DX(3)/DELTA
C      WRITE(CMSGNM,FMT='(F8.3,F8.3,F8.3,A)')DX,
C     &   ' = normalized lattice spacings dx,dy,dz'
C      CALL WRIMSG('REAPAR',CMSGNM)

C and replaced by following:

      DX(1)=1.
      DX(2)=1.
      DX(3)=1.

C-----------------------------------------------------------------------
C***********************************************************************
C
C   Obtain names of file(s) containing dielectric function(s)
C   NCOMP = number of different dielectric functions
C   CFLEPS(1-NCOMP) = names of files containing dielectric functions
C
!      READ(IOPAR,FMT=*,ERR=40)NCOMP
C
C*** Check that MXCOMP is large enough *********************************
      IF(NCOMP.GT.MXCOMP)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP > MXCOMP: must increase MXCOMP in DDSCAT')
  
C
C*** Check that NCOMP=2 if CSHAPE=UNICYL *******************************
C                     3           ANIELL
C                     2           TWOELL
C                     3           THRELL
C                     6           TWOAEL
C                     9           THRAEL
C                     2           CONELL
C                     2           TWOSPH
C                     2-4         LYRSLB
      IF(CSHAPE.EQ.'UNICYL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option UNICYL')
      IF(CSHAPE.EQ.'ANIELL'.AND.NCOMP.NE.3)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 3 for option ANIELL')
      IF(CSHAPE.EQ.'TWOELL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option TWOELL')
      IF(CSHAPE.EQ.'THRELL'.AND.NCOMP.NE.3)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 3 for option THRELL')
      IF(CSHAPE.EQ.'TWOAEL'.AND.NCOMP.NE.6)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 6 for option TWOAEL')
      IF(CSHAPE.EQ.'THRAEL'.AND.NCOMP.NE.9)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 9 for option THRAEL')
      IF(CSHAPE.EQ.'CONELL'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option CONELL')
      IF(CSHAPE.EQ.'TWOSPH'.AND.NCOMP.NE.2)
     &   CALL ERRMSG('FATAL','REAPAR',
     &   'NCOMP must be 2 for option TWOSPH')
      IF(CSHAPE.EQ.'LYRSLB')THEN
         IF(SHPAR(5).LE.0.)THEN
            J=2
         ELSE
            IF(SHPAR(6).LE.0.)THEN
               J=3
            ELSE
               J=4
            ENDIF
         ENDIF
         IF(J.NE.NCOMP)
     &      CALL ERRMSG('FATAL','REAPAR',
     &      'option LYRSLB; NCOMP incompatible with SHPAR(4-6)')
      ENDIF
C
C***********************************************************************
C
!      READ(IOPAR,FMT=*,ERR=40)CDIEL
      IF(CDIEL.EQ.'TABLES')THEN
!f90 we define all names from the namelist
!         DO 1000 J=1,NCOMP
!             READ(IOPAR,FMT=*,ERR=40)CFLEPS(J)
! 1000    CONTINUE
      ELSEIF(CDIEL.EQ.'H2OICE'.OR.CDIEL.EQ.'H2OLIQ')THEN
         IF(NCOMP.GT.1)CALL ERRMSG('FATAL','REAPAR',
     &                              'H2OICE/LIQ with NCOMP>1?')
      ELSE
         CALL ERRMSG('FATAL','REAPAR','Unrecognized option for CDIEL')
      ENDIF


C***********************************************************************
C
C    Define INITIALIZATION:
C
C    INIT = 0 to start with |X0>=0
C           1 to obtain |X0> from 4th-order expansion in polarizability
C           2 to read |X0> from file solvp.in
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*,ERR=40)INIT
      IF(INIT.EQ.0)THEN
         CALL WRIMSG('REAPAR',
     &               'INIT=0 to start with |X0>=0 (CCG method)')
      ELSEIF(INIT.EQ.1)THEN
         CALL WRIMSG('REAPAR',
     &         'INIT=1 to obtain |X0> from 4th-order expansion (CCG)')
      ELSEIF(INIT.EQ.2)THEN
         CALL WRIMSG('REAPAR',
     &        'INIT=2 to read |X0> from file solvp.in')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong value of INIT')
      ENDIF

C***********************************************************************
C
C    Define error tolerance:
C
C    TOL= maximum acceptable value of |Ax-E|/|E|
C
!f90      READ(IOPAR,FMT=*,ERR=40)TOL
      IF(TOL.GT.1.E-15.AND.TOL.LT.1.E-1)THEN
         WRITE(CMSGNM,FMT='(1P,E10.3,A)')TOL,
     &         ' = TOL = max. acceptable normalized residue |Ax-E|/|E|'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('WARNING','REAPAR',' Strange value of TOL ')
      ENDIF


C***********************************************************************
C
C    Define number of theta and phi values for evaluation of CSCA and G
C
C    ICTHM = number of thetan values to use in evaluation of CSCA, G
C            (must be odd; recommend ICTHM=33)
C    IPHM  = number of phin values to use in evaluation of CSCA, G
C            (even or odd; recommend IPHM=12 or more)
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*)ICTHM
      IF((ICTHM+1)/2*2 .NE. (ICTHM+1))THEN
         CALL ERRMSG('FATAL','REAPAR',' ICTHM SHOULD BE ODD ')
      ELSE
         WRITE(CMSGNM,FMT='(I4,A)')ICTHM,
     &' - ICTHM; number of THETAN values for calc.of g and Qsca by SCAT'
         CALL WRIMSG('REAPAR',CMSGNM)
      ENDIF
!f90      READ(IOPAR,FMT=*)IPHM
      WRITE(CMSGNM,FMT='(I4,A)')IPHM,
     &' - IPHM; number of PHIN values for calc. of g and Qsca by SCAT'
      CALL WRIMSG('REAPAR',CMSGNM)



C***********************************************************************
C
C    Define WAVELENGTH :
C
C    WAVINI = first wavelength (physical units)
C    WAVEND = last wavelength (physical units)
C    NWAV   = number of wavelengths
C    CDIVID = 'LIN', 'LOG', or 'INV' for equal increments in
C             wavelength, log(wavelength), or frequency
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*,ERR=40)WAVINI,WAVEND,NWAV,CDIVID
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')
     &      NWAV,' wavelengths from ',WAVINI,' to ',WAVEND
      CALL WRIMSG('REAPAR',CMSGNM)
!f90 replaced cdivid with cwav
      CALL DIVIDE(CWAV,WAVINI,WAVEND,NWAV,MXWAV,WAVEA)

C***********************************************************************
C
C    Define AEFF = radius of equal-volume sphere (physical units)
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*)AEFINI,AEFEND,NRAD,CDIVID
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')
     &      NRAD,' eff. radii from ',AEFINI,' to ',AEFEND
      CALL WRIMSG('REAPAR',CMSGNM)
!f90 replaced cdivid with crad
      CALL DIVIDE(CRAD,AEFINI,AEFEND,NRAD,MXRAD,AEFFA)
 
C***********************************************************************
C
C    Define incident polarizations (in Lab Frame)
C    It is assumed that incident radiation is along x axis in Lab Frame
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
C
C Read complex polarization vector CXE01=e01 (normalize if necessary).
C
!f90      READ(IOPAR,FMT=*,ERR=40)CXE01
      E1=REAL(SQRT(CXE01(1)*CONJG(CXE01(1))))
      IF(E1.NE.0.)THEN
         CALL ERRMSG('FATAL','REAPAR',' CXE01(1) must be zero!')
      ENDIF

C
C Normalize:
C
      E1=SQRT(REAL(CXE01(2)*CONJG(CXE01(2))+CXE01(3)*CONJG(CXE01(3))))
      CXE01(2)=CXE01(2)/E1
      CXE01(3)=CXE01(3)/E1
C
C Construct orthogonal normalized polarization vector CXE02=e02
C using xhat cross e01* = e02
C
      CXE02(1)=(0.,0.)
      CXE02(2)=-CONJG(CXE01(3))
      CXE02(3)=CONJG(CXE01(2))

C
C IORTH=1 to calculate only for single polarization
C      =2 to also calculate for orthogonal polarization
C
!f90      READ(IOPAR,FMT=*,ERR=40)IORTH
C
C***********************************************************************
C
C    Specify whether or not to write ".sca" files
C
C IWRKSC=0 to NOT write ".sca" file for each target orientation
C       =1 to write ".sca" file for each target orientation
C
!f90      READ(IOPAR,FMT=*,ERR=40)IWRKSC
C
C***********************************************************************
C
C    Read information determining target rotations
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*)BETAMI,BETAMX,NBETA
!f90      READ(IOPAR,FMT=*)THETMI,THETMX,NTHETA
!f90      READ(IOPAR,FMT=*)PHIMIN,PHIMAX,NPHI
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*)IWAV0,IRAD0,IORI0
C
C*** Check that values of NBETA,NTHETA,NPHI are OK:
C
      IF(NBETA.GT.MXBETA) then

         CALL ERRMSG('FATAL','REAPAR',' NBETA>MXBETA: must recompile')
      endif
      IF(NPHI.GT.MXPHI)
     &   CALL ERRMSG('FATAL','REAPAR',' NPHI>MXPHI: must recompile')
      IF(NTHETA.GT.MXTHET)
     &   CALL ERRMSG('FATAL','REAPAR',' NTHETA>MXTHET: must recompile')
C
C***  Check that IWAV0,IRAD0,IORI0 are OK:
C
      IF(IWAV0+1.GT.NWAV)
     &   CALL ERRMSG('FATAL','REAPAR','IWAV0+1 > NWAV')
      IF(IRAD0+1.GT.NRAD)
     &   CALL ERRMSG('FATAL','REAPAR','IRAD0+1 > NRAD')
      IF(IORI0+1.GT.NBETA*NTHETA*NPHI)
     &   CALL ERRMSG('FATAL','REAPAR','IORI0+1 > NBETA*NTHETA*NPHI')
C
C If NPHI>1, then set IORTH=2 regardless of value input.
C
      IF(IORTH.EQ.1.AND.NPHI.GT.1)THEN
         IORTH=2
         CALL WRIMSG('REAPAR',
     &               'Set IORTH=2 since NPHI>1 ')
      ENDIF

C
      IF(IORTH.EQ.1)THEN
         CALL WRIMSG('REAPAR',
     &               'Calculate only for single polarization ')
      ELSEIF(IORTH.EQ.2)THEN
         CALL WRIMSG('REAPAR',
     &               'Do orthogonal polarization for each case ')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' WRONG VALUE OF IORTH ')
      ENDIF
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')BETAMI,BETAMX,
     &  ' Range of BETA values ; NBETA =',NBETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')THETMI,THETMX,
     &  ' Range of THETA values; NTHETA=',NTHETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')PHIMIN,PHIMAX,
     &  ' Range of PHI values ;   NPHI =',NPHI
      CALL WRIMSG('REAPAR',CMSGNM)
C
C Convert from degrees to radians
C
      BETAMI=BETAMI/DEGRAD
      BETAMX=BETAMX/DEGRAD
      THETMI=THETMI/DEGRAD
      THETMX=THETMX/DEGRAD
      PHIMIN=PHIMIN/DEGRAD
      PHIMAX=PHIMAX/DEGRAD
      
C
C***********************************************************************
C
C    Specify elements of scattering matrix to be printed out
C
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90      READ(IOPAR,FMT=*,ERR=40)NSMELTS
C
C NSMELTS = number of elements of scattering matrix element to be
C           printed out.  Must be no greater than 9
C           if NSMELTS is zero, then 6 "default" elements are output
C
      IF(NSMELTS.GT.9)THEN
         WRITE(IDVOUT,FMT='(A,I2,A)')'Error:',NSMELTS,
     &      ' > 9 is not permitted by output routines'
         CALL ERRMSG('FATAL','REAPAR',
     &               'NSMELTS > 9 is not allowed in ddscat.par')
      ENDIF
      IF(NSMELTS.LE.0)THEN
         SMIND1(1)=11
         SMIND1(2)=21
         SMIND1(3)=31
         SMIND1(4)=41
         SMIND1(5)=12
         SMIND1(6)=13
         NSMELTS=6
         READ(IOPAR,FMT=*)
      ELSE
!f90         READ(IOPAR,FMT=*,ERR=40)(SMIND1(J),J=1,NSMELTS)
      ENDIF
      DO J=1,NSMELTS
         SMIND2(J)=SMIND1(J)-10*(SMIND1(J)/10)
         SMIND1(J)=SMIND1(J)/10
      ENDDO
    
C***********************************************************************
C
C    Specify scattering directions to be calculated
C    THETAN,PHIN = Direction of n from n0 in calculation of the
C                  scattering matrix; cos(THETAN) is n0 \dot n
C                  and PHIN is azimuthal angle of n from Lab xy plane
C                  Note: THETA1, THETA2, and PHI for each scattering
C                  plane are entered in degrees, and immediately 
C                  converted to radians.  Arbitrary number
C                  of scattering planes may be considered.
C
      NSCA=0

!WARNING
! This section of reapar.f is not properly converted and allows for only one
! phi-plane. The solution is to introduce array phi(ndirs)
!
!f90      READ(IOPAR,FMT=*,ERR=40)CLINE
!f90      CALL WRIMSG(' ',CLINE)
!f90 22   READ(IOPAR,FMT=*,ERR=40,END=25)PHI1,THETA1,THETA2,DTHETA
!f90 PJF have added do loop over NDIRS
! WARNING. NDIRS HAS to be =1 currenty
! this can be easily coded with arrays phi, theta1, theta2

      do idirs=1,ndirs
      WRITE(CMSGNM,FMT='(3F7.1,A)')PHI1,THETA1,THETA2,
     &  ' = phi, theta_min, theta_max for scattering plane'
      CALL WRIMSG('REAPAR',CMSGNM)
C
C Convert to radians:
C


      PHI1=PHI1/DEGRAD
      THETA1=THETA1/DEGRAD
      THETA2=THETA2/DEGRAD
      DTHETA=DTHETA/DEGRAD
C
C Allow for possibility that user did not enter correct sign for
C DTHETA (if I did it, others will too...)
C
      IF(THETA2.LT.THETA1)DTHETA=-ABS(DTHETA)
C
C compute theta values for this scattering plane
C
      NSCA0=1

      DELTA=THETA2-THETA1

      IF(DELTA.NE.0)NSCA0=1+INT(DELTA/DTHETA+0.5)

C
C Check that there is enough storage space:
C
      IF((NSCA+NSCA0).GT.MXSCA)THEN
         WRITE(IDVOUT,FMT='(I6,I6,A)')MXSCA,NSCA0,
     &         ' =MXSCA,NSCA0 (dirs in this scatt. plane)'
         CALL ERRMSG('FATAL','REAPAR',
     &               'MXSCA too small in DDSCAT')
      ENDIF
      THETAN(NSCA+1)=THETA1

      IF(NSCA0.GT.2)THEN
         DO J=2,NSCA0-1
            THETAN(NSCA+J)=THETA1+(J-1)*DTHETA
         ENDDO
      ENDIF
      THETAN(NSCA+NSCA0)=THETA2
      DO J=1,NSCA0
         PHIN(NSCA+J)=PHI1
      ENDDO
      NSCA=NSCA+NSCA0

      WRITE(CMSGNM,FMT='(I4,A)')NSCA0,
     &  ' = number of scattering angles in this scattering plane'
      CALL WRIMSG('REAPAR',CMSGNM)
!f90 PJF ok - end of f90 changes
      enddo
 25   CONTINUE
C
C Check that if user has requested computation of f_ml, user has
C also requested linearly-polarized incident radiation.
C 96.01.25 (BTD) We have disabled this "protection".  So long as user
C is aware that when using elliptical incident polarization the
C f_ml are not the "usual" ones with index l referring to linearly
C polarized incident modes, there is not reason not to allow user
C to calculate f_ml for the the scattered radiation.
C
C      IF(NSCA.GT.0)THEN
C         DO 26 J=1,3
C            IF(AIMAG(CXE01(J)).NE.0.)CALL ERRMSG('FATAL','REAPAR',
C     &      'pol. vector E01 is complex: DDSCAT cannot compute f_ml, so 
C     &do not ask it to!')
C 26      CONTINUE
C      ENDIF
C
      CLOSE (IOPAR)
      RETURN
   40 CONTINUE
      CALL ERRMSG('FATAL','REAPAR',' Error reading ddscat.par file')
      RETURN
      END
