      SUBROUTINE WRIMSG(CSUBRT,CMSGNM)
      IMPLICIT NONE
C Standard procedure for writing messages
C
C Copyright (C) 1993, B.T. Draine and P.J. Flatau
C This code is covered by the GNU General Public License.
C
C History:
C 96.11.14 (PJF) Remove "getset" and hardwire" ioout"
C 96.11.20 (BTD) change IOOUT to IDVOUT
C***********************************************************************
C     .. Scalar Arguments ..
      CHARACTER CMSGNM* (*), CSUBRT* (*)
C     ..
C     .. Local Scalars ..
      INTEGER IDVOUT
      SAVE IDVOUT
C     ..
C Note: on some systems (e.g., Solaris) IDVOUT=0 generates unbuffered
C output to "standard output".  On other systems IDVOUT=0 may not be
C valid; then set IDVOUT=6 to get "standard output", probably buffered.
C
      DATA IDVOUT/0/
      WRITE (IDVOUT,FMT=9000) CSUBRT, CMSGNM
 9000 FORMAT (' >',A,' ',A)
      RETURN
      END
